clear all
close all
clc
%%
load datos
%% Creando con todos los datos y separando una variable
%D=som_data_struct([inputs outputs], 'comp_names',[inputvar;outputvar],'labels',labels,'name','autompg'); %Crear la estructura con todas las variables juntas
%D=somng_outputvar(D,size(D.data,2)); % La ultima variable pasa a ser la variable de salida

%% Creando con la variable de entrada y aadiendo despus
D=som_data_struct(inputs,'comp_names',inputvar,'labels',labels,'name','autompg');
D.values=outputs; D.value_name=outputvar;

%% Normalizacin con una funcin modificada
T=som_normalize(D,'var');

w0=som_randinit(T,'rect','msize',[10 5]);
w=somngs_batchtrain(w0,T,'trainlen',50,'gamma',10,'sigma',prod(w0.topol.msize)/2,'tracking',-2);
% trainlen = numero de epocas
% sigma = radio de vecindad inicial
% gamma = constante de preservacion topologica
% tracking = resultados por epocas similar al original, si es negativo solo
%            sale al final segun la trackplot modificada. 
%            Para sacar cada 10 epocas se pone -2.010, 20 con -2.020, etc
%% Estimaciones y errores
rmse = som_mse(w,T); % Normalizado
rmse2 = som_mse(w,T,'denorm'); % Desnormalizando
est = som_estimate(w,T);
figure(2)
subplot(1,2,1); scatter(T.values,est,'.b'); 
title(['Normalizado, rmse= ', num2str(rmse)]); xlabel('Valor real'); ylabel('Valor estimado');

est2 = som_estimate(w,T,'outdenorm');
subplot(1,2,2); scatter(D.values,est2,'.b'); 
title(['Desnormalizado, rmse= ', num2str(rmse2)]); xlabel('Valor real'); ylabel('Valor estimado');

%%
figure(3);
som_show(w,'comp',0:5); %El cero representa la variable de salida
figure(4);
somng_gradshow(w); % Representa los mapas de gradientes