function [] = trackplot(M,D,tracking,start,n,qe,fig)
if nargin<7, fig= gcf(); end
l=length(qe);

if (floor(tracking)~=tracking), step=round((abs(tracking)-floor(abs(tracking)))*1000);
else step=NaN; end
if (tracking>=1), refresh=true;
elseif (mod(n,l)==0), refresh=true;
elseif (mod(n,step)==0), refresh=true;
else return;
end
if isstruct(M),
    est=som_estimate(M,D(:,1:end-1));
    M=[M.codebook M.values];
end
dat=min(size(qe));
if(refresh)
    elap_t = etime(clock,start);
    tot_t = elap_t*l/n;
    fprintf(1,'Training: %3d/%3d. %s/ %s\n',n,l,time2str(elap_t),time2str(tot_t))   %#ok<PRTCAL>
    if n>l, tracking=1; end
    switch floor(abs(tracking))
        case 1,
        case 2,
            figure(fig)
            if(dat==1),
                plot(1:n,qe(1:n),(n+1):l,qe((n+1):l));
                title(['qe: ' num2str(qe(n))]);
            elseif(dat==2)
                plot(1:n,qe(1,1:n),n+1:l,qe(1,n+1:l),'b')
                hold on;plot(1:n,qe(2,1:n),'g',n+1:l,qe(2,n+1:l),'k');hold off
                title(['qe: ' num2str(qe(1,n)) ', te: ' num2str(qe(2,n))]);
                legend('qe','te');
            end
            drawnow
        otherwise,
            figure(fig)
            subplot(2,1,1)
            if(dat==1),
                plot(1:n,qe(1:n),(n+1):l,qe((n+1):l));
                title(['qe: ' num2str(qe(n))]);
            else
                plot(1:n,qe(1,1:n),n+1:l,qe(1,n+1:l),'b')
                hold on;plot(1:n,qe(2,1:n),'g',n+1:l,qe(2,n+1:l),'k');hold off
                legend('qe','te');
                title(['qe: ' num2str(qe(1,n)) ', te: ' num2str(qe(2,n))])
                
            end
            subplot(2,1,2);
            if size(M,2)==2
                plot(D(:,1),D(:,2),'b.',M(:,1),M(:,2),'ro');
                title('First two components of map units (o) and data vectors (.)');
                if exist('est','var')
                    hold on;
                    plot(D(:,1),est,'g.');
                    hold off;
                end
            else
                plot3(D(:,1),D(:,2),D(:,3),'b.',M(:,1),M(:,2),M(:,3),'ro');
                title('First three components of map units (o) and data vectors (.)');
            end
            drawnow
    end
end
end
%% subfunctions


function [ str ] = time2str( t )

if length(t)>1, t=t(end-3:end)*[86400;3600;60;1]; end

if t<0, str='-'; t=abs(t);
else str=[];
end;
d = floor(t/86400);         t=t-d*86400;
h = floor(t/3600);          t=t-h*3600;
m = floor(t/60);            t=t-m*60;

if d>0, str=[str num2str(d) ' d ']; end
if h>0, str=[str num2str(h) ' h ']; end
if m>0, str=[str num2str(m) ' min ']; end
if t>0, str=[str num2str(t,4) 's']; end

end

