% Copyright (C) 2017. University of Oviedo. All rights reserved.
% Author: Ivn Machn-Gonzlez
%
% Please, if you use it, cite the following work:
% Ivn Machn-Gonzlez and Hilario Lpez-Garca, Feedforward Nonlinear Control Using Neural Gas Network, Complexity, vol. 2017, Article ID 3125073, 11 pages, 2017. doi:10.1155/2017/3125073

clear
close all
clc

load w_arm
w=w_arm;

dim=size(w.codebook,2);

codebooks=w.codebook;



yi_values=w.values;
vectors=w.vectors;
% valores de media y desviacin tpica para la des/normalizacin de la variable de salida 'y'
mu_values=w.value_norm.params(1);
sigma_values=w.value_norm.params(2);

%las medias de las variables componentes quedan en un vector mu_comp de dimension 1xdim
%las desviaciones tpicas de las variables componentes quedan en un vector sigma_comp de dimension 1xdim
for i=1:dim
mu_comp(i)=w.comp_norm{i}.params(1);
sigma_comp(i)=w.comp_norm{i}.params(2);
end

%Denormalize codebook vectors
for i=1:dim
codebooks_dn(:,i)=codebooks(:,i)*sigma_comp(i)+mu_comp(i); 
end

%Denormalize gradient vectors to obtain partial derivatives
for i=1:dim;
    dydu(:,i)=w.value_norm.params(2)*w.vectors(:,i)/w.comp_norm{i}.params(2);
end